unit FileMaps;

// file mapping (c)2001 by Paul TOTH <tothpaul@free.fr>
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
 windows,sysutils;

Type
 TFileMapping=class
 private
  fFile:integer;
  fMap :integer;
  fBase:pointer;
  fSize:Cardinal;
 public
  Constructor Create(AFileName:string);
  Destructor Destroy; override;
  function data(index:Cardinal):pointer;
  property Base:pointer read fBase;
  property Size:Cardinal read fSize;
 end;

implementation

Constructor TFileMapping.Create(AFileName:string);
 begin
  fFile:=CreateFile(PChar(AFileName),GENERIC_READ,FILE_SHARE_READ,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
  if fFile=0 then raise Exception.Create('Unable to open '+AFileName);
  fSize:=GetFileSize(fFile,0);
  if fSize=0 then raise Exception.Create('Empty file '+AFileName);
  fMap :=CreateFileMapping(fFile,nil,PAGE_READONLY,0,0,nil);
  if fMap=0 then raise Exception.Create('Can''t map file '+AFileName);
  fBase:=MapViewOfFile(fMap,FILE_MAP_READ,0,0,0);
  if fBase=nil then raise Exception.Create('Can''t view file '+AFileName);
 end;

Destructor TFileMapping.Destroy;
 begin
  UnMapViewOfFile(fBase);
  CloseHandle(fMap);
  CloseHandle(fFile);
  inherited Destroy;
 end;

function TFileMapping.Data(index:Cardinal):pointer;
 begin
  if (index<0)or(index>fSize) then raise Exception.Create('Out of bounds pointer !');
  result:=pointer(integer(fBase)+index);
 end;

end.
