unit WinGLReg;
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
interface
}

interface

uses
 Classes,DsgnIntf,
 WinGL,ZIPFiles;

procedure Register;

implementation

Type
 TZIPNameProperty=class(TStringProperty)
  function GetAttributes: TPropertyAttributes; override;
  procedure GetValues(Proc: TGetStrProc); override;
 end;

function TZIPNameProperty.GetAttributes: TPropertyAttributes;
begin
 Result:=[paValueList];
end;

procedure TZIPNameProperty.GetValues(Proc: TGetStrProc);
var
 GLImage:TGLImage;
 i:integer;
begin
 GLImage:=GetComponent(0) as TGLImage;
 if (GLImage.ZIPFile<>nil) then begin
  for i:=0 to GLImage.ZIPFile.EntryCount-1 do proc(GLImage.ZIPFile.Entries[i].Name);
 end;
end;

procedure Register;
begin
  RegisterComponents('MySoft.GL', [TWinGL,TGLTex,TGLLight,TGLImage]);
  RegisterPropertyEditor(TypeInfo(string),TGLImage,'ZIPName',TZIPNameProperty);
end;


end.
