unit ZIPFiles;

{ I think that the Inflate code can hang sometime...
  any help to make this bad code readable is welcome :)
}
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
interface
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TZIPFile  = class;

  TZIPEntry = class
  private
   fOwner:TZIPFile;
   fName :string;  // original file nale
   fSize :integer; // real file size
   fPos  :integer; // archive pos in TZIPFile resource
   fLen  :integer; // compressed size
   procedure SaveToStream(AStream:TStream);
   procedure LoadFromStream(AStream:TStream);
  public
   Constructor Create(AOwner:TZIPFile);
   procedure ExtractTo(p:pointer);
   function GetImage:pointer;
   property Name:string  read fName;
   property Size:integer read fSize;
  end;

  TSlide=array[0..$7FFF] of byte;
  PSlide=^TSlide;
(*
  THuffItem=packed record
   BitCount :byte;
   ExtraBits:byte;
   Code     :word;
   HuffList :array of THuffItem;   :(
  end;
*)
  TZIPFile = class(TComponent)
  private
    { Dclarations prives }
   fStream :TMemoryStream;
   fEntries:TList;
   function GetEntry(Index:integer):TZIPEntry;
  protected
    { Dclarations protges }
  // inflate parms
   fSource :^byte;
   fLen    :integer;
   fSize   :integer;
   fData   :^byte;
   fBits   :integer; // actual bits
   fLeft   :integer; // bits left
   fSlide  :PSlide;
   fSSize  :word;    // not an integer !
//   fLengths:array of THuffItem;
//   fDistances:array of THuffItem;
   function NextBits(count:integer):integer;
   procedure SkipBits(count:integer);
   function ReadBits(count:integer):integer;
   procedure Flush;
   procedure Inflate;
   procedure InflateStored;
   procedure InflateFixed;
   procedure InflateDynamic;
   procedure InflateCodes(htl,htd:pointer; bl,bd:integer);
   procedure ReadData(AStream:TStream; Size:integer);
   procedure Extract(Offset,Len,Size:integer; Data:pointer);
   procedure SaveEntries(Stream: TStream);
   procedure LoadEntries(Stream: TStream);
  public
   Constructor Create(AOwner:TComponent); override;
   Destructor Destroy; override;
   procedure DefineProperties(Filer: TFiler); override;
   procedure LoadFromFile(AFileName:string);
   procedure LoadFromStream(AStream:TStream);
   procedure Clear;
   function ExtractByName(AName:string):pointer;
   function EntryCount:integer;
   property Entries[index:integer]:TZIPEntry read GetEntry;
  published
    { Dclarations publies }
  end;

implementation

{ the Inflate code is based on Pascal source codes by
   Christian Ghisler
  and
   Dr Abimbola Olowofoyeku (The African Chief),
  and
   C code by info-zip group, translated to pascal by Christian Ghisler
}
type
 PHuffList =^THuffList;
 THuffItem =packed record
  ExtraBits:byte;
  BitCount :byte;
  Code     :word;
  SubTree  :PHuffList; // Linked List
 end;
 PHuffItem =^THuffItem;
 PPHuffItem=^PHuffItem;

 THuffList = array[0..8191] of THuffItem; // 1 shl 13 codes ?

const
// Copy lengths for literal codes 257..285
 cplens: array[0..30] of word = (
   3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31,
  35,43,51,59,67,83,99,115,131,163,195,227,258,  0,  0
 );
// Extra bits for literal codes 257..285
 cplext: array[0..30] of word = (
  0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2,
  3, 3, 3, 3, 4, 4, 4, 4, 5, 5, 5, 5, 0, 99, 99
 );
// Copy offsets for distance codes 0..29
 cpdist:array [0..29] of word = (
  1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193,
  257, 385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145,
  8193, 12289, 16385, 24577
 );
// Extra bits for distance codes
 cpdext:array [0..29] of word = (
  0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6,
  7, 7, 8, 8, 9, 9, 10, 10, 11, 11,
  12, 12, 13, 13
 );

// Order of the bit length code lengths
 border:array[0..18] of byte = (
 16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15
 );

// build huffman table from code lengths
procedure BuildHuffList(
   var b  :array of word; // length list [0..255/287/287+32] of word
       n,s:word;
 const d,e:array of word; // one of the const array above
       t  :PPHuffItem;    // Huffman table
   var m  :integer);
var a : word;                   {counter for codes of length k}
    c : array[0..17] of word;   {bit length count table}
    f : word;                   {i repeats in table every f entries}
    g,                          {max. code length}
    h : integer;                {table level}
    i,                          {counter, current code}
    j : word;                   {counter}
    k : integer;                {number of bits in current code}
    p : pword;                  {pointer into c, b and v}
    q : PHuffList;              {points to current table}
    r : THuffItem;              {table entry for structure assignment}
    u : array[0..16] of PHuffList;{table stack}
    v : array[0..288] of word;  {values in order of bit length}
    w : integer;                {bits before this table}
    x : array[ 0..17] of word;  {bit offsets, then code stack}
    l : array[-1..17] of word;  {l[h] bits in table of level h}
    xp : ^word;                      {pointer into x}
    y : integer;                     {number of dummy codes added}
    z : word;                        {number of entries in current table}
    tryagain : boolean;              {bool for loop}
    pt : PHuffItem;                  {for test against bad input}
    el : word;                       {length of eob code=code 256}
begin
 if n>256 then el:=b[256] else el:=16;
{generate counts for each bit length}
 FillChar(c,SizeOf(c),0);
 for i:=0 to n-1 do inc(c[b[i]]);
 if c[0]=n then begin // all null
  t^:=nil;
  m:=0;
  exit
 end;
{find minimum and maximum length, bound m by those}
 j:= 1; while (j<=16)and(c[j]=0) do inc(j); k:=j;
 i:=16; while (i > 0)and(c[i]=0) do dec(i); g:=i;
 if m<j then m:=j;
 IF m>i then m:=i;
{adjust last length count to fill out codes, if needed}
 y:=1 shl j;
 while j<i do begin
  y:=y-c[j];
  y:=y shl 1;
  inc(j);
 end;
 dec(y,c[i]);
 inc(c[i],y);
{generate starting offsets into the value table for each length}
 j:=0;
 x[1]:=0;
 for i:=1 to g do begin
  inc(j,c[i]);
  x[i+1]:=j;
 end;
{make table of values in order of bit length}
 for i:=0 to n-1 do begin
  j:=b[i];
  if j<>0 then begin
   v[x[j]]:=i;
   inc(x[j]);
  end;
 end;
{generate huffman codes and for each, make the table entries}
 x[0]:=0;
 i:=0;
 p:=@v;
 h:=-1;
 l[-1]:=0;
 w:=0;
 u[0]:=nil;
 q:=nil;
 z:=0;
{go through the bit lengths (k already is bits in shortest code)}
 for k:=k to g do begin
  for a:=c[k] downto 1 do begin
  {here i is the huffman code of length k bits for value p^}
   while k>w+l[h] do begin
    inc(w,l[h]); {Length of tables to this position}
    inc(h);
    z:=g-w;
    if z>m then z:=m;
    j:=k-w;
    f:=1 shl j;
    if f>a+1 then begin
     dec(f,a+1);
     xp:=@c[k];
     inc(j);
     tryagain:=True;
     while (j<z) and tryagain do begin
      f:=f shl 1;
      inc(longint(xp), sizeof(word));
      if f<=xp^ then
       tryagain:=False
      else begin
       dec(f,xp^);
       inc(j);
      end;
     end;
    end;
    if (w+j>el) and (w<el) then j:=el-w;       {Make eob code end at table}
    if w=0 then j:=m;  {*** Fix: main table always m bits!}
    z:=1 shl j;
    l[h]:=j;
   {allocate and link new table}
    getmem(q,(z+1)*SizeOf(THuffItem));
    fillchar(q^,(z+1)*SizeOf(THuffItem),0);
    q^[0].Code:=z;  {Size of table, needed in freemem ***}
    t^:=@q^[1];    {first item starts at 1}
    t :=@q^[0].SubTree;
    t^:= NIL;
    q :=@q^[1];   {pointer(longint(q)+sizeof(huft));} {???}
    u[h]:=q;
   {connect to last table, if there is one}
    if h<>0 then begin
     x[h]:=i;
     r.BitCount:=l[h-1];
     r.ExtraBits:=16+j;
     r.SubTree:=q;
     j:=( i and ((1 shl w)-1)) shr (w-l[h-1]);
     pt:=@u[h-1]^[j];
     pt^:=r;
    end;
   end;
  {set up table entry in r}
   r.BitCount:=word(k-w);
   r.SubTree:=nil;  {Unused}   {***********}
   if longint(p)>=longint(@v[n]) then
    r.ExtraBits:=99
   else
   if p^<s then begin
    if p^<256 then r.ExtraBits:=16 else r.ExtraBits:=15;
    r.Code:= p^;
    inc(longint(p),SizeOf(word));
   end else begin
    r.ExtraBits:=word(e[p^-s]);
    r.Code:=d[p^-s];
    inc(longint(p),SizeOf(word));
   end;
  {fill code like entries with r}
   f:=1 shl(k-w);
   j:=i shr w;
   while j<z do begin
    q^[j]:=r;
    inc(j,f);
   end;
  {backwards increment the k-bit code i}
   j:=1 shl (k-1);
   while (i and j)<>0 do begin
    i:=i xor j;
    j:=j shr 1;
   end;
   i:=i xor j;
  {backup over finished tables}
   while ((i and ((1 shl w)-1))<>x[h]) do begin
    dec(h);
    dec(w,l[h]); {Size of previous table!}
   end;
  end;
 end;
end;

procedure FreeHufft(t:PHuffList);
var p, q : PHuffList;
begin
 p:=pointer(t);
 while p<>nil do begin
  dec(longint(p),sizeof(THuffItem));
  q:=p^[0].SubTree;
  freemem(p);
  p:=q
 end;
end;

//-----------------------------------------------------------------//

Constructor TZIPEntry.Create(AOwner:TZIPFile);
 begin
  fOwner:=AOwner;
 end;

procedure TZIPEntry.SaveToStream(AStream:TStream);
 var
  i:integer;
 begin
  i:=Length(fName);
  AStream.WriteBuffer(i,SizeOf(i));
  AStream.WriteBuffer(fName[1],i);
  AStream.WriteBuffer(fSize,SizeOf(fSize));
  AStream.WriteBuffer(fPos ,SizeOf(fPos ));
  AStream.WriteBuffer(fLen ,SizeOf(fLen ));
 end;

procedure TZIPEntry.LoadFromStream(AStream:TStream);
 var
  i:integer;
 begin
  AStream.ReadBuffer(i,SizeOf(i));
  SetLength(fName,i);
  AStream.ReadBuffer(fName[1],i);
  AStream.ReadBuffer(fSize,SizeOf(fSize));
  AStream.ReadBuffer(fPos ,SizeOf(fPos ));
  AStream.ReadBuffer(fLen ,SizeOf(fLen ));
 end;

Procedure TZIPEntry.ExtractTo(p:pointer);
 begin
  fOwner.Extract(fPos,fLen,fSize,p);
 end;

function TZIPEntry.GetImage:pointer;
 begin
  GetMem(Result,fSize);
  ExtractTo(Result);
 end;

Constructor TZIPFile.Create(AOwner:TComponent);
 begin
  inherited;
  fStream :=TMemoryStream.Create;
  fEntries:=TList.Create;
 end;

Destructor TZIPFile.Destroy;
 begin
  Clear;
  fEntries.Free;
  fStream.Free;
  inherited;
 end;

procedure TZIPFile.DefineProperties(Filer:TFiler);
 begin
  inherited;
  Filer.DefineBinaryProperty('Entries', LoadEntries, SaveEntries, fEntries.Count<>0);
 end;

procedure TZIPFile.SaveEntries(Stream:TStream);
 var
  e,i:integer;
 begin
  e:=fEntries.Count;
  Stream.WriteBuffer(e,SizeOf(e));
  for i:=0 to e-1 do TZIPEntry(fEntries[i]).SaveToStream(Stream);
  e:=fStream.Size;
  Stream.WriteBuffer(e,SizeOf(e));
  Stream.CopyFrom(fStream,0);
 end;

procedure TZIPFile.LoadEntries(Stream:TStream);
 var
  e,i:integer;
  zip:TZIPEntry;
 begin
  Stream.ReadBuffer(e,SizeOf(e));
  for i:=0 to e-1 do begin
   zip:=TZIPEntry.Create(Self);
   zip.LoadFromStream(Stream);
   fEntries.Add(zip);
  end;
  Stream.ReadBuffer(e,SizeOf(e));
  fStream.CopyFrom(Stream,e);
 end;

procedure TZIPFile.LoadFromFile(AFileName:string);
 var
  s:TStream;
 begin
  s:=TFileStream.Create(AFileName,fmOpenRead or fmShareDenyNone);
  try
   LoadFromStream(s);
  finally
   s.Free;
  end;
 end;

Const
 PK34=$04034B50; // 'PK'#3#4
Type
 TPK34 = packed record
  sign : longint;
  extract_ver,
  bit_flag,
  zip_type : word;
  file_timedate : longint;
  crc_32,
  compress_size,
  uncompress_size : longint;
  filename_len,
  extra_field_len : word;
 end;

procedure TZIPFile.LoadFromStream(AStream:TStream);
 begin
  ReadData(AStream,AStream.Size);
 end;

procedure TZIPFile.ReadData(AStream:TStream; Size:integer);
 var
  head:TPK34;
  name:string;
  entry:TZIPEntry;
 begin
  // read any PK34 header
  while Size>SizeOf(head) do begin
   AStream.ReadBuffer(head,sizeof(head));
   if head.sign<>PK34 then break;
   dec(Size,SizeOf(Head));
   SetLength(name,head.filename_len);
   AStream.ReadBuffer(name[1],head.filename_len);
   AStream.position:=AStream.position+head.extra_field_len;
   dec(Size,head.filename_len+head.extra_field_len);
   if (head.compress_size>0)and((1 shl head.zip_type) and (1+1 shl 8)<>0) then begin
    entry:=TZIPEntry.Create(self);
    entry.fName:=name;
    entry.fSize:=head.uncompress_size;
    entry.fPos :=fStream.Position;
    entry.fLen :=head.compress_size;
    fStream.CopyFrom(AStream,head.compress_size);
    fEntries.Add(entry);
   end else begin
  //  ShowMessage('Unsupported compression ['+IntToStr(head.zip_type)+'] for '+name);
    fStream.Position:=fStream.Position+head.compress_size;
   end;
   dec(Size,head.compress_size);
  end;
  if Size>0 then fStream.Position:=fStream.Position+Size;
 end;

procedure TZIPFile.Clear;
 var
  i:integer;
 begin
  fStream.Clear;
  for i:=0 to fEntries.Count-1 do TZIPEntry(fEntries[i]).Free;
  fEntries.Clear;
 end;

function TZIPFile.ExtractByName(AName:string):pointer;
 var
  i:integer;
 begin
  for i:=0 to fEntries.Count-1 do with TZIPEntry(fEntries[i]) do begin
   if Name=AName then begin
    Result:=GetImage;
    exit;
   end;
  end;
  Result:=nil;
 end;

procedure TZIPFile.Extract(Offset,Len,Size:integer; Data:pointer);
 begin
{$ifdef log}
 AssignFile(output,'TZIPFile.log');
 Rewrite(output);
 try
{$endif}
  fSource:=fStream.Memory;
  inc(fSource,Offset);
  if Len=Size then begin // stored
   Move(fSource^,Data^,Size);
  end else begin // deflated
   fLen :=Len;
   fSize:=Size;
   fData:=Data;
   Inflate;
  end;
{$ifdef log}
 finally
 closefile(output);
 end;
{$endif}
 end;

function TZIPFile.NextBits(count:integer):integer;
 begin
  while Count>fLeft do begin
   fBits:=fBits or (fSource^ shl fLeft);
   inc(fSource);
   inc(fLeft,8);
  end;
  Result:=fBits and pred(1 shl count);
 end;

procedure TZIPFile.SkipBits(count:integer);
 begin
  dec(fLeft,count);
  fBits:=fBits shr Count;
 end;

function TZIPFile.ReadBits(count:integer):integer;
 begin
  Result:=NextBits(count);
  SkipBits(count);
 end;

procedure TZIPFile.Flush;
 begin
  if fSSize>0 then begin
   move(fSlide[0],fData^,fSSize);
   inc(fData,fSSize);
   fSSize:=0;
  end;
 end;

procedure TZIPFile.Inflate;
 var
  last:boolean;
 begin
  fBits:=0; // actual bits
  fLeft:=0; // bits left
  New(fSlide);
  fSSize:=0;
  repeat
   last:=ReadBits(1)=1;
   case ReadBits(2) of
    0 : InflateStored;
    1 : InflateFixed;
    2 : InflateDynamic;
    else raise Exception.Create('Inflate error #1');
   end;
  until last;
  Flush;
  Dispose(fSlide);
 end;

procedure TZIPFile.InflateStored;
 var
  size:integer;
  count:integer;
 begin
 // byte boundary
  if (fLeft and 7)<>0 then SkipBits(fLeft and 7);
 // get size
  size:=ReadBits(16);
 // check size
  if (not size)<>ReadBits(16) then raise Exception.Create('InflateStored error #1');
 // copy data
  while size>0 do begin
   if fSSize+size>SizeOf(TSlide) then count:=SizeOf(TSlide)-fSSize else count:=size;
   dec(size,count);
   Move(fSource^,fSlide[fSSize],count);
   inc(fSource,count);
   dec(fSize,count);
   inc(fSSize,count);
   if fSSize=SizeOf(TSlide) then Flush;
  end;
 end;

var
 HufftLen :array[0..287] of word;
 HufftDist:array[0.. 29] of word;

procedure TZIPFile.InflateFixed;
 var
  tl,td:pointer;
  bl,bd:integer;
 begin
 // Huffman table for Length codes
  bl:=7; BuildHuffList(HufftLen ,288,257,cplens,cplext,tl,bl);
 // Huffman table for Distance codes
  bd:=5; BuildHuffList(HufftDist, 30,  0,cpdist,cpdext,td,bd);
 // let's go
  InflateCodes(tl,td,bl,bd);
 // destroy Huffman tables
  FreeHufft(tl);
  FreeHufft(td);
 end;

procedure TZIPFile.InflateDynamic;
var
 i,j,k:integer;                      {temporary variables}
 code :word;
 count:integer;
 n : word;                         {number of lengths to get}
 tl,                             {literal/length code table}
 td : PHuffList;                   {distance code table}
 bl, bd : integer;                  {lookup bits for tl/bd}
 nb, nl, nd : word;                  {number of bit length/literal length/distance codes}
 ll:array[0..288 + 32 - 1] of word;  {literal/length and distance code lengths}
BEGIN
// read in table lengths
  nl := 257 + ReadBits(5); // Literals  : 0..287
  nd :=   1 + ReadBits(5); // Distances : 0..31
  nb :=   4 + ReadBits(4); // Bits      : 0..18
  FillChar(ll,SizeOf(ll),0);
// read in bit-length-code lengths
  for j:=0  to nb-1 do ll[border[j]]:=ReadBits(3);
  for j:=nb to 18   do ll[border[j]]:=0;
// build decoding table for trees--single level, 7 bit lookup
  bl:=7; BuildHuffList(ll,19,19,{dummy}cplens,cplens{/dummy},@tl,bl);
// read in literal and distance code lengths
  n:=nl+nd;
  i:=0;
  code:=0; // initial code
  while i<n do begin
   td:=@tl^[NextBits(bl)]; SkipBits(PHuffItem(td)^.BitCount);
   count:=PHuffItem(td)^.Code;
   if count<16 then begin   // length of code in bits
    code :=count;
    count:=1;
   end else
   if count=16 then begin  // repeat last length
    count:=3+ReadBits(2);  // 3..6
   end else
   if count=17 then begin  // zero length codes
    code :=0;
    count:=3+ReadBits(3);  // 3..10
   end else begin          // zero length codes
    code :=0;
    count:=11+ReadBits(7); // 11..138
   end;
  // copy "count" codes of value "code"
   for k:=i to i+count-1 do ll[k]:=code;
   inc(i,count);
  end;
  FreeHufft(tl);  {free decoding table for trees}
// build the decoding tables for literal/length and distance codes
  bl:=9; BuildHuffList(ll    ,nl,257,cplens,cplext,@tl,bl);
  bd:=6; BuildHuffList(ll[nl],nd,  0,cpdist,cpdext,@td,bd);
// decompress until an end-of-block code
  InflateCodes(tl,td,bl,bd);
// release tables
  FreeHufft(tl);
  FreeHufft(td);
END;

procedure TZIPFile.InflateCodes(htl,htd:pointer; bl,bd:integer);
VAR
    n, d, e1:word;     {length and index for copy}
    t : PHuffItem;         {pointer to table entry}
    e : byte;          {table entry flag/number of extra bits}
   tl,td:PHuffList;
const
 SlideSize = $8000;
BEGIN
 tl:=htl;
 td:=htd;
 { inflate the coded data }
  while fSize>0 do begin
   t:=@tl^[NextBits(bl)]; // read code
   SkipBits(t^.BitCount); // the real bits count
   e:=t^.ExtraBits;       // is there a sub tree ?
   while e>16 do begin    // step into the tree
    t:=@t^.SubTree^[NextBits(e-16)];
    SkipBits(t^.BitCount);
    e:=t^.ExtraBits;
   end;
   if e=15 then exit;  // end of block
   if e=16 then begin
    fSlide[fSSize]:=t^.Code;
    inc(fSSize);
    if fSSize=SlideSize then Flush;
    dec(fSize);
   end else begin           // it's a length
    n:=t^.Code+ReadBits(e); // get length of block to copy
    t:=@td^[NextBits(bd)];  // decode distance of block to copy
    SkipBits(t^.BitCount);
    e:=t^.ExtraBits;
    while e>16 do begin
     t:=@t^.SubTree^[NextBits(e-16)];
     SkipBits(t^.BitCount);
     e:=t^.ExtraBits;
    end;
    d:=fSSize-t^.Code-ReadBits(e);
   {do the copy}
    repeat
     d:=d and (SlideSize-1);
  {$ifdef log}
   writeln('d=',d,' w=',fSSize,' n=',n);
  {$endif}
     if d>fSSize then e1:=SlideSize - d
                 else e1:=SlideSize - fSSize;
     if e1>n then e1:=n;
     dec(n,e1);
    {$ifdef log}write(' n=',n,' "');{$endif}
     if (fSSize-d>=e1) then begin
      move(fSlide[d],{fData^}fSlide[fSSize],e1);
    {$ifdef log}write('"+"',copy(pchar(fSlide),d,e1),'"+"'); {$endif}
      inc(fSSize,e1);
     // inc(fData,e1);
      dec(fSize,e1);
      inc(d,e1);
     end else
     repeat
     // fData^:=ord(fSlide[d]);
      fSlide[fSSize]:=fSlide[d];
      {$ifdef log}write(fSlide[d]);{$endif}
     // inc(fData);
      dec(fSize);
      inc(fSSize);
      inc(d);
      dec(e1);
     until (e1=0);
    {$ifdef log}writeln('" w=',fSSize);{$endif}
     if fSSize=SlideSize then begin
    {$ifdef log}writeln('reset slide');{$endif}
      Flush;
      //fSlide:=pointer(fData);
     end;
    until n=0;
   end;
  end;
 end;

function TZIPFile.EntryCount:integer;
 begin
  result:=fEntries.Count;
 end;

function TZIPFile.GetEntry(index:integer):TZIPEntry;
 begin
  result:=fEntries[Index];
 end;

procedure InitFixedHuffTable;
 var
  i:integer;
 begin
 // Huffman table for Length codes
  for i:=  0 to 143 do HufftLen[i]:=8;
  for i:=144 to 255 do HufftLen[i]:=9;
  for i:=256 to 279 do HufftLen[i]:=7;
  for i:=280 to 287 do HufftLen[i]:=8;
 // Huffman table for Distance codes
  for i:=  0 to  29 do HufftDist[i]:=5;
 end;

initialization
 InitFixedHuffTable;

end.
