unit ZIPFilesEditor;
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
interface
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ZIPFiles;

type
  TZIPFileEdit = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    ZIPFile1: TZIPFile;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
    fZIPFile:TZIPFile;
    procedure SetZIPFile(Value:TZIPFile);
  public
    { Dclarations publiques }
    property ZIPFile:TZIPFile write SetZIPFile;
  end;

var
  ZIPFileEdit: TZIPFileEdit;

procedure Register;

implementation

{$R *.dfm}

uses
{$IFDEF VER140 aka Delphi 6}
 DesignIntf, DesignEditors;
{$ELSE}
 DsgnIntf;
{$ENDIF}
Type
 TZIPFileEditor=class(TComponentEditor)
  function GetVerbCount:integer; override;
  function GetVerb(index:integer):string; override;
  procedure ExecuteVerb(index:integer); override;
  procedure Edit; override;
 end;

function TZIPFileEditor.GetVerbCount:integer;
 begin
  result:=1;
 end;

function TZIPFileEditor.GetVerb(index:integer):string;
 begin
  result:='Edit...';
 end;

procedure TZIPFileEditor.ExecuteVerb(index:integer);
 begin
  Edit;
 end;

procedure TZIPFileEditor.Edit;
 begin
  with TZIPFileEdit.Create(Application) do begin
   ZIPFile:=TZIPFile(Component);
   ShowModal;
   Free;
  end;
 end;


procedure Register;
 begin
  RegisterComponentEditor(TZIPFile,TZIPFileEditor);
 end;

procedure TZIPFileEdit.SetZIPFile(Value:TZIPFile);
 var
  i:integer;
 begin
  fZIPFile:=Value;
  Caption:=fZIPFile.Name;
  ListBox1.Clear;
  ListBox1.Items.BeginUpdate;
  for i:=0 to fZIPFile.EntryCount-1 do ListBox1.Items.add(fZIPFile.Entries[i].Name);
  ListBox1.Items.EndUpdate;
 end;

procedure TZIPFileEdit.Button1Click(Sender: TObject);
 begin
  if OpenDialog1.Execute then begin
   fZIPFile.LoadFromFile(OpenDialog1.FileName);
    ZIPFile:=fZIPFile;
  end;
 end;

procedure TZIPFileEdit.Button2Click(Sender: TObject);
begin
 fZIPFile.Clear;
  ZIPFile:=fZIPFile;
end;

end.
